<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 6.1: Basics of Structures</title>
<link href="sx9.html" rev=precedes>
<link href="sx9b.html" rel=precedes>
<link href="sx9.html" rev=subdocument>
</head>
<body>
<H2>section 6.1: Basics of Structures</H2>

<p>Don't get too excited about the prospect of doing graphics
in C--there's
no one standard or portable way of doing it,
so the points and rectangles we're going to be discussing
must remain abstract for now
(we won't be able to plot them out).
</p><p>page 128
</p><p>To summarize the syntax of structure declarations:
A structure declaration has about four parts,
most of them optional:
the keyword <TT>struct</TT>,
a <dfn>structure tag</dfn> (optional),
a brace-enclosed list of declarations for the 
<dfn>members</dfn>
(also called ``fields'' or ``components'')
of the structure (optional),
and a list of variables of the new structure type (optional).
The arrangement looks like this:
<pre>	struct <I>tag</I> {
		<I>member declarations</I>
	} <I>declared variables</I> ;
</pre>Normally, a structure declaration defines either a tag and the members,
or some variables based on an existing tag,
or sometimes all three at once.
That is,
we might first declare a structure:
<pre>	struct point {			/* 1 */
		int x;
		int y;
	};
</pre>and then some variables of that type:
<pre>	struct point here, there;	/* 2 */
</pre>Or, we could combine the two:
<pre>	struct point {			/* 3 */
		int x;
		int y;
	} here, there;
</pre>The list of members
(if present)
describes what the new structure ``looks like inside.''
The list of variables
(if present)
is
(obviously)
the list of variables of this new type
which we're defining
and which the rest of the program will use.
The tag
(if present)
is just an arbitrary name for the structure type itself
(not for any variable we're defining).
The tag is used to associate a structure definition
(as in fragment 1)
with a later declaration of variables of that same type
(as in fragment 2).
</p><p>One thing to beware of:
when you declare the members of a structure without defining any variables,
always remember
the trailing semicolon,
as shown
in fragment 1
above.
(If you forget it,
the compiler will wait until the next thing it finds in your source file,
and try to define <em>that</em>
as a variable or function of the structure type.)
</p><hr>
<p>
Read sequentially:
<a href="sx9.html" rev=precedes>prev</a>
<a href="sx9b.html" rel=precedes>next</a>
<a href="sx9.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
